/* 

   HMG Sample : 
   
     SET WINDOW ... variances
     
   By Bicahi Esgici 
   
   August 2014 : First release
   April 2015 : Added : Move window anywhere on screen
                        A different animation when user enter wrong ID / psw
   
*/

#include <hmg.ch>

#define MAXATTEMPT 3

PROCEDURE Main()

    lConfirmed := .F.
    
    SET WINDOW MAIN OFF
    CheckUser()  
    SET WINDOW MAIN ON
    
    IF lConfirmed
        DEFINE WINDOW frmMain ;
           AT 0,0 ;
           WIDTH 400 HEIGHT 400 ;
           TITLE 'Main Window' ;
           MAIN
           ON KEY ESCAPE ACTION ThisWindow.Release      
           @ 150,150  BUTTON Button_1 CAPTION "What is this ?" ACTION MsgInfo ("This is MAIN window of this program.") 
        END WINDOW
        
        CENTER WINDOW frmMain
        ACTIVATE WINDOW frmMain
    ENDIF
	
RETURN // Main()

*-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.

PROCEDURE CheckUser()  

    LOCAL cPictFNm := "FoldLock", nPicWidth, nPicHeight, aPicBackColor
   
    nCursRow    := GetCursorPos()[ 1 ]
    nCursCol    := GetCursorPos()[ 2 ]
	
    IF HMG_GetImageInfo( cPictFNm, @nPicWidth, @nPicHeight, @aPicBackColor )
   
        DEFINE WINDOW frmCheckUser;
            AT 0,0;  
            WIDTH nPicWidth;
            HEIGHT nPicHeight;
            BACKCOLOR aPicBackColor; 
            NOSYSMENU;
            NOSIZE;
            NOMINIMIZE;
            NOMAXIMIZE; 
            NOCAPTION;
            TOPMOST;
            CHILD ;
		    ON MOUSEDRAG MoveForm() ;       
	        ON MOUSEMOVE SetCoords()
            
		    ON KEY ESCAPE ACTION ThisWindow.Release
		    
            SET WINDOW frmCheckUser TRANSPARENT TO COLOR aPicBackColor
            
            @ 0, 0 IMAGE Image_1 PICTURE cPictFNm 
            
            @ 100,  30 LABEL   lblUserID VALUE "User ID :"  TRANSPARENT FONTCOLOR YELLOW BOLD
            @  95,  85 TEXTBOX txbUserID WIDTH 90 HEIGHT 20  ON ENTER { || frmCheckUser.txbPasswrd.SetFocus }
            @ 130,  40 LABEL   lblPaswrd VALUE "Password :" TRANSPARENT FONTCOLOR YELLOW BOLD
            @ 125, 110 TEXTBOX txbPasswrd WIDTH 90 HEIGHT 20 PASSWORD ON ENTER { || frmCheckUser.btnApply.SetFocus }
		    
            DEFINE BUTTON btnApply 
               ROW 180
               COL 80 
               PICTURE "key32png"
               TOOLTIP "Login" 
               WIDTH 42 
               HEIGHT 42            
               ACTION ConfirmUser()
            END BUTTON    
           
        END WINDOW  // frmCheckUser
	    
        frmCheckUser.Cursor := "DragCurs"
        frmCheckUser.Center()
        frmCheckUser.Activate()
         
    ELSE
        MsgStop( cPictFNm + " image file open error !. Program aborted !", "ERROR !" )
    ENDIF
   
RETURN // CheckUser()     

*-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.

PROCEDURE ConfirmUser()

    STATIC nAttempt := 0
	
	LOCAL n2Right, n2Left, nRepeat
    
    LOCAL cUserID := frmCheckUser.txbUserID.Value,;
          cPassword := frmCheckUser.txbPasswrd.Value         
    
    IF cUserID == "demo" .AND. cPassword == "demo"   
        MsgInfo( "Login allowed" )
	    lConfirmed := .T.
        frmCheckUser.Release       
    ELSE
        IF ++nAttempt < MAXATTEMPT
		    FOR nRepeat := 1 TO 3
    		    nColumn := frmCheckUser.Col 
	            FOR nStep := 1 TO 50 STEP 10
					nColumn += nStep
				    ThisWindow.Col := nColumn
                    INKEY( .02 )					
				NEXT	
	            FOR nStep := 1 TO 50 STEP 10
				    nColumn := frmCheckUser.Col 
					nColumn -= nStep
				    ThisWindow.Col := nColumn
                    INKEY( .02 )					
				NEXT		     
            NEXT 			
            MsgStop( "Wrong user ID or Password !", "ERROR" )
        ELSE   
            QUIT
        ENDIF            
    ENDIF 
RETURN // ConfirmUser()

*-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.

PROC MoveForm()

   LOCAL nCurWRow  := frmCheckUser.Row,;
         nCurWCol  := frmCheckUser.Col
         
   LOCAL nCursRowC := GetCursorPos()[ 1 ],;
         nCursColC := GetCursorPos()[ 2 ]
         
   LOCAL nDiffVert :=  nCursRow - nCurWRow,;
         nDiffHorz :=  nCursCol - nCurWCol
         
   nCurWRow := MAX( nCursRowC - nDiffVert, 0 )
   
   frmCheckUser.Row := nCurWRow
   
   nCurWCol := MAX( nCursColC - nDiffHorz, 0 )
   
   frmCheckUser.Col := nCurWCol   
   
   nCursRow := GetCursorPos()[ 1 ]
   nCursCol := GetCursorPos()[ 2 ]
   
RETU // MoveForm()

*-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.

PROCEDURE SetCoords() 

   nCursRow := GetCursorPos()[ 1 ]
   nCursCol := GetCursorPos()[ 2 ]
   
RETU // SetCoords() 

*-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.
